authTypeSelect();

function authTypeSelect() {
    const authType = document.getElementById("auth_type");
    const userpass = document.getElementById("userpass");
    const certkey = document.getElementById("certkey");
    const user = document.getElementById("username");
    const pass = document.getElementById("password");

    if (authType.value == "userpass") {
        userpass.style.display = "block";
        certkey.style.display = "none";
        user.setAttribute("required", "");
        pass.setAttribute("required", "");
    } else {
        userpass.style.display = "none";
        certkey.style.display = "block";
        user.removeAttribute("required");
        pass.removeAttribute("required");
    }
}

function close_vpn_popup() {
    document.getElementById("vpn_progress_overlay").style.visibility = "hidden";
    window.location.reload();
}

function vpn_progress(ev) {
    var prev_offset = ev.target.x_processed_until || 0;
    var offset = ev.loaded;
    ev.target.x_processed_until = offset;
    var box = document.getElementById("vpn_progress_text");

    if (prev_offset == 0) {
        box.innerHTML = ""
    }
    var lines = ev.target.response.slice(prev_offset, offset).split('\n');
    for (var i = 0; i < lines.length; i++) {
        // XXX color ERROR etc
        var p = document.createElement("p");
        p.innerText = lines[i];
        box.appendChild(p);
    }
}

function vpn_setup(form) {
    document.getElementById("vpn_progress_text").innerHTML = "";
    const formData = new FormData(form);
    var xhr = new XMLHttpRequest();
    xhr.addEventListener('progress', vpn_progress);

    xhr.open(form.method, form.action, true);
    xhr.send(formData);
}

function vpn_start_setup(ev) {
    ev = ev || windows.event;

    // abort normal post to avoid page reloading
    ev.preventDefault();

    if (!window.confirm('起動中のコンテナを全て停止する必要があります。停止したコンテナはVPN接続後自動的に起動します。よろしいですか？')) {
        return false;
    }

    // open popup
    document.getElementById("vpn_progress_overlay").style.visibility = "visible";

    // start xhr and feed popup
    vpn_setup(ev.target);
    return false;
}

document.addEventListener("DOMContentLoaded", function(_ev) {
    var elements = document.getElementsByClassName("vpn_post");
    for (var i = 0; i < elements.length; i++) {
        elements[i].addEventListener('submit', vpn_start_setup);
    }
    document.getElementById("vpn_progress_close").addEventListener("click", close_vpn_popup);
})
